#!/usr/bin/env node
import * as app from 'commander';
import { OdataMetadata }  from 'odata-context';

import { OdataParser, IConfig } from './src/OdataParser';

app.version("2.0.0-beta.3")
    .arguments('<url>')
    .option('-d, --directory <directory>', 'directory where to place models')
    .option('-n, --service-name <name>', 'name of generating service')
    .option('-s, --service-dir <dir>', 'directory of generating service')
    .option('-c, --skip-context', 'skip context creation')
    .option('-i, --import <import>', 'odata-context import')
    .option('--skip-service', 'skip service creation')
    .action(async (url) => {
        const parser = new OdataParser({
            url,
            dir: app.directory,
            serviceDir: app.serviceDir,
            serviceName: app.serviceName,
            skipContext: app.skipContext,
            skipService: app.skipService,
            import: app.import
        });        
        await parser.onInitialize;
        parser.CreateEntities();
    })
    .parse(process.argv);