"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var odata_context_1 = require("odata-context");
var fs = require("fs");
var jsdom = require("jsdom");
var Helpers_1 = require("./templates/Helpers");
var static_classes_1 = require("./templates/static-classes");
var service_1 = require("./templates/service");
var OdataParser = (function () {
    function OdataParser(config) {
        var _this = this;
        this.config = config;
        this.imports = [];
        this.url = config.url;
        this.dir = config.dir || './models';
        this.skipService = config.skipService || false;
        this.skipContext = config.skipContext || false;
        this.serviceDir = config.serviceDir || this.dir;
        this.serviceName = config.serviceName || 'OdataService';
        this.import = config.import || 'odata-context';
        this.staticClasses = new static_classes_1.StaticClasses(this.import);
        this.serviceGenerator = new service_1.Service(this.serviceDir, this.dir, this.import, this.serviceName, this.url);
        this.onInitialize = new Promise(function (resolve, reject) {
            _this._initialized = resolve;
            _this._failed = reject;
        });
        this.init();
    }
    OdataParser.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var $, promise, metadata, _a, _b, _c, ex_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        $ = null;
                        promise = new Promise(function (resolve, reject) {
                            jsdom.env("", function (err, window) {
                                if (err) {
                                    reject(err);
                                }
                                $ = require("jquery")(window);
                                $.get(_this.url + '/$metadata', function (data) {
                                    resolve($(data));
                                }).fail(reject);
                            });
                        });
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, promise];
                    case 2:
                        metadata = _d.sent();
                        _a = this;
                        _b = odata_context_1.OdataMetadata.bind;
                        _c = [void 0, this.url, null, $];
                        return [4 /*yield*/, promise];
                    case 3:
                        _a.metadata = new (_b.apply(odata_context_1.OdataMetadata, _c.concat([_d.sent()])))();
                        this._initialized();
                        return [3 /*break*/, 5];
                    case 4:
                        ex_1 = _d.sent();
                        this._failed(ex_1);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    OdataParser.prototype.CreateEntities = function () {
        var _this = this;
        if (!fs.existsSync(this.dir)) {
            fs.mkdirSync(this.dir);
            console.log('Created dir', this.dir);
        }
        fs.writeFileSync(this.dir + "/IFilterable.ts", this.staticClasses.IFilterable());
        fs.writeFileSync(this.dir + "/ISelectable.ts", this.staticClasses.ISelectable());
        fs.writeFileSync(this.dir + "/IExpandable.ts", this.staticClasses.IExpandable());
        var typesContent = '';
        this.metadata.entityTypes.forEach(function (entityType) { return __awaiter(_this, void 0, void 0, function () {
            var file;
            return __generator(this, function (_a) {
                file = this.dir + "/" + entityType.namespace + "." + entityType.name + ".ts";
                fs.writeFile(file, this.CreateEntity(entityType), function (err) { return err && console.error(err); });
                typesContent += this.CreateImport(entityType.namespace, entityType.name);
                console.log('Created entity', file);
                return [2 /*return*/];
            });
        }); });
        this.metadata.complexTypes.forEach(function (complexType) { return __awaiter(_this, void 0, void 0, function () {
            var file;
            return __generator(this, function (_a) {
                file = this.dir + "/" + complexType.namespace + "." + complexType.name + ".ts";
                fs.writeFile(file, this.CreateEntity(complexType), function (err) { return err && console.error(err); });
                typesContent += this.CreateImport(complexType.namespace, complexType.name);
                console.log('Created entity', file);
                return [2 /*return*/];
            });
        }); });
        this.metadata.entityTypes.forEach(function (entityType) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                typesContent += " export type I" + entityType.name + " = I" + entityType.name + "Model & Partial<I" + entityType.name + "ModelNavigationProperties> & Partial<I" + entityType.name + "ModelActions>;\n\n";
                return [2 /*return*/];
            });
        }); });
        if (!this.skipContext) {
            var file = this.dir + "/core.ts";
            fs.writeFile(file, this.CreateEntitySets(this.metadata.entitySets), function (err) { return err && console.error(err); });
            console.log('Created context', file);
        }
        if (!this.skipService) {
            if (!fs.existsSync(this.serviceDir)) {
                fs.mkdirSync(this.serviceDir);
                console.log('Created folder', this.serviceDir);
            }
            var file = this.serviceDir + "/" + this.serviceName + ".ts";
            fs.writeFile(file, this.serviceGenerator.Generate(), function (err) { return err && console.error(err); });
            console.log('Created service', file);
        }
        fs.writeFileSync(this.dir + "/types.ts", typesContent);
        console.log("TypesCreated " + this.dir + "/types.ts");
    };
    OdataParser.prototype.CreateSet = function (set) {
        var types = Helpers_1.Helpers.GetTypes(set.entityType.name);
        return "    " + set.name + ": OdataDbSet<" + types.join(', ') + ">;";
    };
    OdataParser.prototype.CreateEntitySets = function (entitySets) {
        var _this = this;
        var content = "import { OdataDbSet } from '" + this.import + "';\n\n";
        entitySets.forEach(function (entitySet) {
            var entityType = entitySet.entityType;
            content += _this.CreateImport(entityType.namespace, entityType.name);
        });
        content += "export interface IOdataSets {\n" + entitySets.map(function (set) { return _this.CreateSet(set); }).join('\n') + "\n}\n";
        return content;
    };
    OdataParser.prototype.CreateProperty = function (entityType, property, any, suffix) {
        if (any === void 0) { any = false; }
        if (suffix === void 0) { suffix = 'Model'; }
        if (property.parsedType.isComplex) {
            console.log('here', property.name);
            var optional_1 = property.isNullable || entityType.keys.includes(property.name);
            var content_1 = "    " + property.name + ((optional_1 || any) ? '?' : '') + ": " + (any ? 'any' : 'I' + property.parsedType.name + suffix) + ";";
            return content_1;
        }
        var type = odata_context_1.OdataHelpers.ParseType(property.type);
        var optional = property.isNullable || entityType.keys.includes(property.name);
        var content = "    " + property.name + ((optional || any) ? '?' : '') + ": " + (any ? 'any' : Helpers_1.Helpers.GetType(type.name, type.isCollection)) + ";";
        return content;
    };
    OdataParser.prototype.CreateNavigationProperty = function (entityType, property) {
        var type = property.parsedType;
        var propType = "I" + type.name + "Model & I" + type.name + "ModelNavigationProperties";
        if (type.isCollection) {
            propType = "Array<" + propType + ">";
        }
        var optional = true;
        var content = "   " + property.name + (optional ? '?' : '') + ": " + propType + ";";
        return content;
    };
    OdataParser.prototype.CreateOdataNavigationProperty = function (entityType, property) {
        var type = property.parsedType;
        var optional = true;
        var content = "   " + property.name + (optional ? '?' : '') + ": I" + type.name + "ModelProperties & I" + type.name + "ModelOdataNavigationProperties;";
        return content;
    };
    OdataParser.prototype.CreateExpandables = function (entityType, property) {
        var type = property.parsedType;
        var optional = true;
        var content = "   " + property.name + (optional ? '?' : '') + ": I" + type.name + "ModelExpandables;";
        return content;
    };
    OdataParser.prototype.CreateFilterables = function (entityType, property) {
        var type = property.parsedType;
        var optional = true;
        var content = "    " + property.name + (optional ? '?' : '') + ": I" + type.name + "ModelFilterables;";
        return content;
    };
    OdataParser.prototype.CreateOrderBy = function (entityType, property) {
        var type = property.parsedType;
        var content = "    " + property.name + "?: I" + type.name + "ModelOrderBy;";
        return content;
    };
    OdataParser.prototype.CreateKeys = function (keys, entityType) {
        if (keys.length === 1) {
            var property = entityType.properties.find(function (prop) { return prop.name == keys[0]; });
            if (property) {
                var type = odata_context_1.OdataHelpers.ParseType(property.type);
                return "export type I" + entityType.name + "ModelKeys = " + Helpers_1.Helpers.GetType(type.name, type.isCollection) + ";";
            }
            else {
                return '';
            }
        }
        else {
            var content = keys.map(function (key) {
                var property = entityType.properties.find(function (p) { return p.name === key; });
                if (property) {
                    var type = odata_context_1.OdataHelpers.ParseType(property.type);
                    return "    " + property.name + ": " + Helpers_1.Helpers.GetType(type.name, type.isCollection) + ";";
                }
                else {
                    return undefined;
                }
            });
            return "export interface I" + entityType.name + "ModelKeys {\n                " + content + "\n            }";
        }
    };
    OdataParser.prototype.CreateSelectables = function (entityType, property) {
        if (property instanceof odata_context_1.OdataNavigationProperty) {
            var type = property.parsedType;
            return "    " + property.name + "?: I" + type.name + "ModelSelectables;";
        }
        else {
            var type_1 = odata_context_1.OdataHelpers.ParseType(property.type);
            return "    " + property.name + "?: any;";
        }
    };
    OdataParser.prototype.GetCountableProperties = function (entityType, property) {
        if (property.parsedType.isCollection) {
            return "    '" + property.name + "@odata.count'?: number;";
        }
        else {
            return undefined;
        }
    };
    OdataParser.prototype.CreateModel = function (entityType) {
        var _this = this;
        var fileContent = '';
        fileContent +=
            "import { IFilterable } from './IFilterable';\nimport { IExpandable } from './IExpandable';\nimport { ISelectable } from './ISelectable';\nimport { IOrderByCommand } from '" + this.import + "';\nimport { Observable } from 'rxjs/Observable';\n\n" + this.CreateKeys(entityType.keys, entityType) + "\n\nexport interface I" + entityType.name + "Model {\n" + entityType.properties.map(function (prop) { return _this.CreateProperty(entityType, prop); }).join('\n') + "\n" + entityType.navigationproperties.map(function (prop) { return _this.GetCountableProperties(entityType, prop); }).join('\n') + "\n}\n\nexport interface I" + entityType.name + "ModelProperties {\n" + entityType.properties.map(function (prop) { return _this.CreateProperty(entityType, prop, !prop.parsedType.isComplex, 'ModelProperties'); }).join('\n') + "\n}\n\nexport interface I" + entityType.name + "ModelNavigationProperties {\n" + entityType.navigationproperties.map(function (prop) { return _this.CreateNavigationProperty(entityType, prop); }).join('\n') + "\n}\n\nexport interface I" + entityType.name + "ModelOdataNavigationProperties {\n" + entityType.navigationproperties.map(function (prop) { return _this.CreateOdataNavigationProperty(entityType, prop); }).join('\n') + "\n}\n\nexport interface I" + entityType.name + "ModelExpandables extends IExpandable {\n" + entityType.navigationproperties.map(function (prop) { return _this.CreateExpandables(entityType, prop); }).join('\n') + "\n}\n\nexport interface I" + entityType.name + "ModelSelectables extends ISelectable {\n" + entityType.properties.map(function (prop) { return _this.CreateSelectables(entityType, prop); }).join('\n') + "\n" + entityType.navigationproperties.map(function (prop) { return _this.CreateSelectables(entityType, prop); }).join('\n') + "\n}\n\nexport interface I" + entityType.name + "ModelFilterables extends IFilterable<\n    I" + entityType.name + "ModelProperties & I" + entityType.name + "ModelOdataNavigationProperties,\n    I" + entityType.name + "ModelOdataNavigationProperties,\n    I" + entityType.name + "ModelFilterables\n> {\n" + entityType.navigationproperties.map(function (prop) { return _this.CreateFilterables(entityType, prop); }).join('\n') + "\n}\n\nexport interface I" + entityType.name + "ModelOrderBy extends IOrderByCommand<\n    I" + entityType.name + "ModelProperties & I" + entityType.name + "ModelOdataNavigationProperties,\n    I" + entityType.name + "ModelOrderBy\n> {\n" + entityType.navigationproperties.map(function (prop) { return _this.CreateOrderBy(entityType, prop); }).join('\n') + "\n}\n\nexport interface I" + entityType.name + "ModelActions {\n    " + entityType.actions.map(function (action) { return _this.GetAction(entityType, action); }).join('\n    ') + "\n}\n\n";
        return fileContent;
    };
    OdataParser.prototype.GetAction = function (entityType, action) {
        var params = [];
        var parameters = action.parameters.filter(function (param) { return param.name != 'bindingParameter'; });
        parameters.forEach(function (param) {
            params.push("" + param.name + (param.isNullable ? '?' : '') + ": " + Helpers_1.Helpers.GetType(param.parsedType.name, param.parsedType.isCollection));
        });
        var returnType = "Observable<void>";
        if (action.returns) {
            var returns = 'any';
            if (action.returnType instanceof odata_context_1.OdataEntityType) {
                returns = "I" + action.returnType.name + "Model & Partial<I" + action.returnType.name + "ModelNavigationProperties> & Partial<I" + action.returnType.name + "ModelActions>";
            }
            else {
                var type = odata_context_1.OdataHelpers.ParseType(action.returnType);
                returns = Helpers_1.Helpers.GetType(type.name, type.isCollection);
            }
            returnType = "Observable<" + returns + ">";
        }
        var content = action.name + "(params: " + (params.length ? '{' : 'any') + params.join(', ') + (params.length ? '}' : '') + "): " + returnType + ";";
        return content;
    };
    OdataParser.prototype.CreateImport = function (namespace, name) {
        var types = Helpers_1.Helpers.GetTypes(name);
        return "import {\n    " + types.join(',\n    ') + "\n} from './" + namespace + "." + name + "';\n\n";
    };
    OdataParser.prototype.CreateEntity = function (entityType) {
        var _this = this;
        var fileContent = "";
        var imports = [];
        entityType.navigationproperties.forEach(function (navProp) {
            var _import = _this.CreateImport(navProp.parsedType.namespace, navProp.parsedType.name);
            if (imports.includes(_import))
                return;
            fileContent += _import;
            imports.push(_import);
        });
        entityType.properties.forEach(function (prop) {
            if (prop.parsedType.isComplex) {
                var _import = _this.CreateImport(prop.parsedType.namespace, prop.parsedType.name);
                if (imports.includes(_import))
                    return;
                fileContent += _import;
                imports.push(_import);
            }
        });
        fileContent += this.CreateModel(entityType);
        return fileContent;
    };
    return OdataParser;
}());
exports.OdataParser = OdataParser;
//# sourceMappingURL=D:/work/odata-context-cli/src/OdataParser.js.map