import { } from 'odata-context';

export class Helpers {
    public static GetTypes(name: string) {
        const types = [
            `I${name}Model`,
            `I${name}ModelProperties`,
            `I${name}ModelNavigationProperties`,
            `I${name}ModelOdataNavigationProperties`,
            `I${name}ModelExpandables`,
            `I${name}ModelSelectables`,
            `I${name}ModelFilterables`,
            `I${name}ModelOrderBy`,
            `I${name}ModelKeys`,
            `I${name}ModelActions`
        ];
        return types;
    }

    public static GetType(type: string, collection: boolean) {
        let res = 'any';
        switch (type) {
            case 'Guid': res = 'string'; break;
            case 'Boolean': res = 'boolean'; break;
            case 'String': res = 'string'; break;
            case 'DateTimeOffset': res = 'string'; break;
            case 'Int32': res = 'number'; break;
            case 'Double': res = 'number'; break;
            default: res = 'any';
        }
        return `${res}${collection? '[]': ''}`;
    }
    
}