"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var Service = (function () {
    function Service(serviceDir, modelsDir, _import, serviceName, url) {
        this.serviceDir = serviceDir;
        this.modelsDir = modelsDir;
        this._import = _import;
        this.serviceName = serviceName;
        this.url = url;
    }
    Service.prototype.Generate = function () {
        var relative = path.posix.relative(this.serviceDir, this.modelsDir);
        var coredir = ('./' + relative + '/core').replace(/\\/ig, "/");
        var content = "import {Injectable} from '@angular/core';\nimport { Http } from '@angular/http';\nimport { OdataMetadata } from '" + this._import + "';\nimport * as $ from 'jquery';\nimport { IOdataSets } from '" + coredir + "';\nimport { Subject } from \"rxjs/Subject\";\n\n@Injectable()\nexport class ExAdminOdataService {\n    private metadata: OdataMetadata<IOdataSets>;\n    private url = '" + this.url + "';\n\n    constructor(private $http: Http) {\n        this.metadata = new OdataMetadata<IOdataSets>(this.url, this.$http);\n    }\n\n    public getContext() {\n        const subject = new Subject<IOdataSets>();\n        this.metadata.getContext().then(context => subject.next(context));\n        return subject.asObservable();\n    }\n}\n";
        return content;
    };
    return Service;
}());
exports.Service = Service;
//# sourceMappingURL=D:/work/odata-context-cli/src/templates/service.js.map